---
title: Building XXX Standalone
slug: Mozilla/Developer_guide/Build_Instructions/Building_XXX_Standalone
tags:
  - Build documentation
  - Developing Mozilla
  - Guide
---
<p>One can build many different products from the source code that can be checked out from Mozilla. There are varying levels of support for some of them, but much is possible. This is an attempt to give an overview of the process of building an arbitrary product and of the process of setting up a build for an arbitrary product in the Mozilla source. The "XXX" product is named after the comment marker that Mozilla implementers tend to use for "to do" or "should do" items or "watch out here" warnings in the source code.</p>
<p>In December of 2007, support for arbitrary build products may have been added and this documentation is an attempt to integrate that new opportunity into the current documentation. See <a class="external" href="http://bugzilla.mozilla.org/show_bug.cgi?id=380846">380846</a> and <a class="link-https" href="https://bugzilla.mozilla.org/show_bug.cgi?id=353983">353983</a>. There are also many documents in the 'Build Documentation' category page and elsewhere that have relevant information.</p>
<p>There is specific documentation for specific products:</p>
<ul>
 <li><a href="/en/Checkout_and_Build_NSPR" title="en/Checkout_and_Build_NSPR">Checkout and Build NSPR</a></li>
 <li><a href="/En/Tamarin_Build_Documentation" title="En/Tamarin_Build_Documentation">Tamarin Build Documentation</a></li>
 <li><a href="/en/XULRunner/Build_Instructions" title="en/XULRunner/Build_Instructions">XULRunner:Build Instructions</a> and <a href="/en/Creating_XULRunner_Apps_with_the_Mozilla_Build_System" title="en/Creating_XULRunner_Apps_with_the_Mozilla_Build_System">Creating XULRunner Apps with the Mozilla Build System</a></li>
 <li><a href="/en/Building_TransforMiiX_standalone" title="en/Building_TransforMiiX_standalone">Building TransforMiiX standalone</a> (marked 'out of date')</li>
 <li><a class="external" href="http://www.songbirdnest.com/node/1771">Building Songbird Standalone</a></li>
 <li><a class="internal" href="/En/Building_Necko_standalone" title="en/Building Necko standalone">Building Necko Standalone</a></li>
 <li><a href="/En/SpiderMonkey/Build_Documentation" title="En/SpiderMonkey/Build_Documentation">Building only SpiderMonkey</a> - the js engine</li>
</ul>
<p>There are three basic steps to building a supported product. First, one must check out the source, which is best done using make. Second, a configure script must be run with the correct flags. The third step is just using make. When the first two steps work correctly, the third is a breeze. Keep in mind that some of this may need to be corrected for <a href="/En/Developer_Guide/Source_Code/Mercurial" title="en/Mozilla_Source_Code_(Mercurial)">building with sources checked out from mercurial</a>.</p>
<p>In order to check out source, there must be a MOZ_CO_PROJECT value used by the mozilla/client.mk file. Currently, there is support in this file for the following products. For some of these, no specific build page exists, but in some cases the build process is easy and the information in the <a href="/En/Developer_Guide/Build_Instructions" title="En/Developer Guide/Build Instructions">Build instructions</a> page will suffice. However, not all products listed are guaranteed to be buildable.</p>
<p>These names are used both as MOZ_CO_PROJECT=&lt;string&gt; in checkout and --enable-application=string in a mozconfig file.</p>
<pre class="eval">* suite - Seamonkey project
* browser - Firefox project
* mail - Thunderbird project
* minimo - small browser for devices, deprecated
* composer - standalone composer, aka NVU
* calendar - Sunbird or Calendar, and Lightning as well
* xulrunner
* camino
</pre>
<p>This is usable as MOZ_CO_PROJECT=string in checkout, but see the <a href="/En/Tamarin_Build_Documentation" title="En/Tamarin_Build_Documentation">Tamarin documentation</a>. Note that this may be obsolete.</p>
<pre class="eval">* tamarin
</pre>
<p>Usable as --enable-application=&lt;string&gt; in a mozconfig file, but for what purpose?</p>
<pre class="eval">* content/xslt - Standalone Transformiix XSLT
* netwerk - Standalone Necko
* tools/update-packaging - AUS-related packaging tools
* standalone - standalone xpcom/xpconnect or for manually driving a build
</pre>
<div class="note">
 <p><strong>Note:</strong> Support for building Necko and Transformiix XSLT standalone was removed in {{Gecko("9.0")}}.</p>
</div>
<p>Third, one can type 'make' (or 'gmake' if needed) and if things are set up correctly, many wonderful things happen and a product is built.</p>
